<?php
function genPDF(&$tof,$name,$pictures) {
	require_once('pdf.php');
	$pdf = new PDF($tof,$name);
	$pdf->addPictures($pictures,MEDIUM);
	$stream = new StdoutStream;
	$pdf->generate($stream);
	exit;
}

function buildTextElementPDF(&$tof,$topicID,$num,$id,$quality=HIGH) {
	require_once('pdf.php');
	$alignments = 
		 array('L'=>'left',
			   'R'=>'right',
			   'C'=>'center');
	$text = $tof->ct->getTextElement($topicID,$num,$id);
	$box = $text['Box'];
	/*
	$page = $tof->ct->getPage($topicID,$num);
	$pdf = new PDF($tof,"TextElement-$topicID-$num-$id.pdf",$box['width'].'x'.$box['height']);
	$pdf->addPage($page,$quality,-$box['left'],-$box['bottom']);
	*/
	$pdf = new PDF(
		$tof,
		"TextElement-$topicID-$num-$id.pdf",
		$box['width']."x".$box['height']);
	$pageID = $pdf->newPage();
	$params = array();
	$params['kern'] = true;
	if ($text['Align'])
		$params['align'] = $alignments[strtoupper($text['Align'])];
	if ($text['Font'])
		$params['font'] = $text['Font'];
	if ($text['Size'])
		$params['height'] = $text['Size'];
	$pdf->pdf->draw_paragraph(
		$box['height'],
		0,
		0,
		$box['width'],
		$text['Text'],
		$pageID,
		$params);
	return $pdf;
}
?>